---
title: HTMLElement.onpaste
slug: Web/API/HTMLElement/onpaste
tags:
  - API
  - Event Handler
  - Experimental
  - HTMLElement
  - NeedsSpecTable
  - Property
  - Reference
---
<div>{{ APIRef("HTML DOM") }} {{SeeCompatTable}}</div>

<p>The <code><strong>HTMLElement.onpaste</strong></code> property of the {{domxref("HTMLElement")}} interface is an {{domxref("EventHandler")}} that processes {{event("paste")}} events.</p>

<p>The <code>paste</code> event fires when the user attempts to paste text.</p>

<p>Note that there is currently no DOM-only way to obtain the text being pasted; you'll have to use an {{ Interface("nsIClipboard") }} to get that information.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>target</em>.onpaste = <em>functionRef</em>;</pre>

<h3 id="Value">Value</h3>

<p><code>functionRef</code> is a function name or a <a href="/en-US/docs/Web/JavaScript/Reference/Operators/function">function expression</a>. The function receives a {{domxref("ClipboardEvent")}} object as its sole argument.</p>

<h2 id="Example">Example</h2>

<p>This example logs every copy and paste attempt to the {{htmlElement("textarea")}}.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;h3&gt;Play with this text area:&lt;/h3&gt;
&lt;textarea id="editor" rows="3"&gt;Try copying and pasting text into this field!&lt;/textarea&gt;

&lt;h3&gt;Log:&lt;/h3&gt;
&lt;p id="log"&gt;&lt;/p&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">function logCopy(event) {
  log.innerText = 'Copied!\n' + log.innerText;
}

function logPaste(event) {
  log.innerText = 'Pasted!\n' + log.innerText;
}

const editor = document.getElementById('editor');
const log = document.getElementById('log');

editor.oncopy = logCopy;
editor.onpaste = logPaste;</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example", 700, 300)}}</p>

<h2 id="Specifications">Specifications</h2>

<p><a href="https://html.spec.whatwg.org/multipage/webappapis.html#handler-onpaste">WHATWG Standard</a></p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLElement.onpaste")}}</p>

<p>Since Firefox 13, the preference <code>dom.event.clipboardevents.enabled</code> controls this feature. It defaults to <code>true</code> but can be disabled.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Clipboard API event {{event("paste")}}</li>
 <li>Related event handlers
  <ul>
   <li>{{domxref("HTMLElement.oncopy")}}</li>
   <li>{{domxref("HTMLElement.oncut")}}</li>
  </ul>
 </li>
</ul>
